pro shockdrift

  vu = 1.
  bu = 1.

  vd = 0.25
  bd = 4.0

  vx = 0.0
  vy = 6.0                      ; suprathermal!

  x = -50.
  y = 0.

  nt = 20000l

  t = genarr(nt, 0.d, 100.d)

  dt = t[1]-t[0]

  vxs = vx
  vys = vy

  xs = x
  ys = y

  for i = 0, nt-1 do begin

     if x LT 0. then begin
        v = vu
        b = bu
     endif else begin
        v = vd
        b = bd
     end
     
     vx = vx + dt*b*vy
     vy = vy + dt*b*(v-vx)

     vxs = [vxs, vx]
     vys = [vys, vy]

     x = x + dt*vx
     y = y + dt*vy

     xs = [xs, x]
     ys = [ys, y]

  end

  wi, 0

  !P.MULTI = [0, 1, 3]

  plot, vxs

  plot, vys

  e = sqrt(vxs^2 + vys^2)

  plot, t, e, psym = 3

  !P.MULTI = 0

  wi, 1

  plot, xs, ys, /isotropic

  openw, l, $
         '/Users/pulupa/Documents/figures/diagrams/shockdrift/shockdrift.txt', $
         /get_lun
  for i = 0, n_elements(xs)-1 do BEGIN
     if (i/10)*10 EQ i then begin
        printf, l, string(xs[i]/10., ys[i]/10., format = '(F8.4," ",F8.4)')
     end
  end

  free_lun, l

  openw, l, $
         '/Users/pulupa/Documents/figures/diagrams/shockdrift/shockdriften.txt', $
         /get_lun
  for i = 0, n_elements(t)-1 do begin
     if (i/10)*10 EQ i then begin
        printf, l, string(t[i]/10.-5., (e[i]-max(e))/4.-2., format = '(F8.4," ",F8.4)')
     END
  end
  free_lun, l

end
